-- scope stuff
qualityoflife = qualityoflife or {};
local q = qualityoflife;

q.modules = q.modules or {};
q.modules["QoL_ClassicThreat-TBC"] = q.modules["QoL_ClassicThreat-TBC"] or {};
local c = q.modules["QoL_ClassicThreat-TBC"];

local profileFrame;
local btnResetAll;
local spacings, spacingIndex = {};

function c:InitOptions()
	c.OPT_VISITED = "OPT_VISITED";

	-- optionsPanel init
	if not c.optionsPanel then
		c.optionsPanel = CreateFrame("Frame", "QoLOptionsFrame_ClassicThreat", q.optionsPanel);
		c.optionsPanel.name = "ClassicThreat";
		c.optionsPanel.parent = q.optionsPanel.name;
		c.optionsPanel.cancel = function(self) c:RevertSettingsChanges(); end;
		InterfaceOptions_AddCategory(c.optionsPanel);
		c.optionsPanel:SetScript("OnShow", function()
			if c.initFinished then
				c:ShowOptionsPanel();
				QOL_OPTIONS[c.name][c.OPT_VISITED] = true;
				c.optionsPanel.oldValues[c.OPT_VISITED] = true;
			end
		end);
		q:HandleElvUi(c.optionsPanel);

		-- workaround for lazy profile loading (addon loading timing problem)
		_G["InterfaceOptionsFrameTab2"]:HookScript("OnClick", function()
			c:ShowOptionsPanel();
		end);

		c:ShowOptionsPanel();
	end

	return true;
end

function c:ShowOptionsPanel()
	spacingIndex, c.optionsPanel.oldValues = 1, q:Deepcopy(QOL_OPTIONS[c.name]);

	-- reset all
	if not btnResetAll then
		btnResetAll = q:CreateOptionsButton(c.optionsPanel, q:GetText("Reset all"), function()
			c:ShowResetDialog();
		end);
		btnResetAll:ClearAllPoints();
		btnResetAll:SetPoint("BOTTOMLEFT", 15, 15);
	end

	C_Timer.After(0.25, function()

	end);
end

function c:InsertSpacing()
	if not spacings[spacingIndex] then
		spacings[spacingIndex] = q:CreateOptionsSpacing(profileFrame);
	end
	spacingIndex = spacingIndex + 1;
end

function c:RevertSettingsChanges()
	QOL_OPTIONS[c.name] = c.optionsPanel.oldValues;
end

function c:SaveSettingsChanges()
	c.optionsPanel.oldValues = q:Deepcopy(QOL_OPTIONS[c.name]);
end